/***
****  QuBE --- Super VGA graphics routines.
****
****  These routines date back awhile, and need some serious upgrading.
****  But they'll work on any VESA 1.0 system, so that's good.
****
****  Please don't use these routines in anything other than QuBE.
***/

/**************************************

   256-Color VESA Super VGA Routines
   C/C++ Header File	 Version 1.0

**************************************/

#ifndef GRAPHICS256
#define GRAPHICS256

#define M40x25x16    1
#define M80x25x16    3
#define M320x200x4   4
#define M640x200x2   6
#define M80x25x2     7
#define M320x200x16  13
#define M640x200x16  14
#define M640x350x2   15
#define M640x350x16  16
#define M640x350x4   16
#define M640x480x2   17
#define M640x480x16  18
#define M320x200x256 19

#define M640x400x256   0x100
#define M640x480x256   0x101
#define M800x600x256   0x103
#define M1024x768x256  0x105
#define M1280x1024x256 0x107

enum {  BLACK = 0, BLUE, GREEN, AQUA, RED, VIOLET, BROWN, LGRAY,
	GRAY, LBLUE, LGREEN, LAQUA, LRED, LVIOLET, YELLOW, WHITE };

#ifndef G_LANG
#ifdef __cplusplus
#define G_LANG "C"
#else
#define G_LANG
#endif
#endif

extern G_LANG int LimitX1;
extern G_LANG int LimitX2;
extern G_LANG int LimitY1;
extern G_LANG int LimitY2;

extern G_LANG int InitScrn(short VidMode);
extern G_LANG void LineXOR(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG void Line(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG void Pixel(int X, int Y, int Color);
extern G_LANG void BoxFillXOR(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG void BoxFill(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG void BoxOutlnXOR(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG void BoxOutln(int X1, int Y1, int X2, int Y2, int Color);
extern G_LANG int PutCharG(int X1, int Y1, char *font, char ch, char color);
extern G_LANG int LenCharG(char *font, char ch);
extern G_LANG int PrintG(int X1, int Y1, char *font, char *string, char color);
extern G_LANG int LenG(char *font, char *string);
extern G_LANG int SetColors(char *colordata, int firstcolor, int totalcolors);
extern G_LANG int GetColors(char *colordata, int firstcolor, int totalcolors);
extern G_LANG int Gprintf(int x, int y, char *font, int color, char *format, ... );
extern G_LANG void GetBitmap(int X, int Y, int width, int height, char *buffer);
extern G_LANG void PutBitmap(int X, int Y, int width, int height, char *buffer);
extern G_LANG void PutBitmapXOR(int X, int Y, int width, int height, char *buffer);
extern G_LANG void PutSprite(int X, int Y, int width, int height, char *buffer);
extern G_LANG void PutSprite0(int X, int Y, int width, int height, char *buffer);
extern G_LANG void MoveBitmap(int SourceX, int SourceY, int width, int height, int DestX, int DestY);
extern G_LANG void WhilePicture(void);
extern G_LANG void WhileRefresh(void);

#endif
